/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB® Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.25.2
        Device            :  PIC16F1827
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set U_sense aliases
#define U_sense_TRIS               TRISA0
#define U_sense_LAT                LATA0
#define U_sense_PORT               RA0
#define U_sense_ANS                ANSA0
#define U_sense_SetHigh()    do { LATA0 = 1; } while(0)
#define U_sense_SetLow()   do { LATA0 = 0; } while(0)
#define U_sense_Toggle()   do { LATA0 = ~LATA0; } while(0)
#define U_sense_GetValue()         RA0
#define U_sense_SetDigitalInput()    do { TRISA0 = 1; } while(0)
#define U_sense_SetDigitalOutput()   do { TRISA0 = 0; } while(0)

#define U_sense_SetAnalogMode()   do { ANSA0 = 1; } while(0)
#define U_sense_SetDigitalMode()   do { ANSA0 = 0; } while(0)
// get/set I_sense aliases
#define I_sense_TRIS               TRISA1
#define I_sense_LAT                LATA1
#define I_sense_PORT               RA1
#define I_sense_ANS                ANSA1
#define I_sense_SetHigh()    do { LATA1 = 1; } while(0)
#define I_sense_SetLow()   do { LATA1 = 0; } while(0)
#define I_sense_Toggle()   do { LATA1 = ~LATA1; } while(0)
#define I_sense_GetValue()         RA1
#define I_sense_SetDigitalInput()    do { TRISA1 = 1; } while(0)
#define I_sense_SetDigitalOutput()   do { TRISA1 = 0; } while(0)

#define I_sense_SetAnalogMode()   do { ANSA1 = 1; } while(0)
#define I_sense_SetDigitalMode()   do { ANSA1 = 0; } while(0)
// get/set P1A aliases
#define P1A_TRIS               TRISB0
#define P1A_LAT                LATB0
#define P1A_PORT               RB0
#define P1A_WPU                WPUB0
#define P1A_SetHigh()    do { LATB0 = 1; } while(0)
#define P1A_SetLow()   do { LATB0 = 0; } while(0)
#define P1A_Toggle()   do { LATB0 = ~LATB0; } while(0)
#define P1A_GetValue()         RB0
#define P1A_SetDigitalInput()    do { TRISB0 = 1; } while(0)
#define P1A_SetDigitalOutput()   do { TRISB0 = 0; } while(0)

#define P1A_SetPullup()    do { WPUB0 = 1; } while(0)
#define P1A_ResetPullup()   do { WPUB0 = 0; } while(0)
// get/set RELAY aliases
#define RELAY_TRIS               TRISB1
#define RELAY_LAT                LATB1
#define RELAY_PORT               RB1
#define RELAY_WPU                WPUB1
#define RELAY_ANS                ANSB1
#define RELAY_SetHigh()    do { LATB1 = 1; } while(0)
#define RELAY_SetLow()   do { LATB1 = 0; } while(0)
#define RELAY_Toggle()   do { LATB1 = ~LATB1; } while(0)
#define RELAY_GetValue()         RB1
#define RELAY_SetDigitalInput()    do { TRISB1 = 1; } while(0)
#define RELAY_SetDigitalOutput()   do { TRISB1 = 0; } while(0)

#define RELAY_SetPullup()    do { WPUB1 = 1; } while(0)
#define RELAY_ResetPullup()   do { WPUB1 = 0; } while(0)
#define RELAY_SetAnalogMode()   do { ANSB1 = 1; } while(0)
#define RELAY_SetDigitalMode()   do { ANSB1 = 0; } while(0)
// get/set YELLOW_LED aliases
#define YELLOW_LED_TRIS               TRISB2
#define YELLOW_LED_LAT                LATB2
#define YELLOW_LED_PORT               RB2
#define YELLOW_LED_WPU                WPUB2
#define YELLOW_LED_ANS                ANSB2
#define YELLOW_LED_SetHigh()    do { LATB2 = 1; } while(0)
#define YELLOW_LED_SetLow()   do { LATB2 = 0; } while(0)
#define YELLOW_LED_Toggle()   do { LATB2 = ~LATB2; } while(0)
#define YELLOW_LED_GetValue()         RB2
#define YELLOW_LED_SetDigitalInput()    do { TRISB2 = 1; } while(0)
#define YELLOW_LED_SetDigitalOutput()   do { TRISB2 = 0; } while(0)

#define YELLOW_LED_SetPullup()    do { WPUB2 = 1; } while(0)
#define YELLOW_LED_ResetPullup()   do { WPUB2 = 0; } while(0)
#define YELLOW_LED_SetAnalogMode()   do { ANSB2 = 1; } while(0)
#define YELLOW_LED_SetDigitalMode()   do { ANSB2 = 0; } while(0)
// get/set RED_LED aliases
#define RED_LED_TRIS               TRISB3
#define RED_LED_LAT                LATB3
#define RED_LED_PORT               RB3
#define RED_LED_WPU                WPUB3
#define RED_LED_ANS                ANSB3
#define RED_LED_SetHigh()    do { LATB3 = 1; } while(0)
#define RED_LED_SetLow()   do { LATB3 = 0; } while(0)
#define RED_LED_Toggle()   do { LATB3 = ~LATB3; } while(0)
#define RED_LED_GetValue()         RB3
#define RED_LED_SetDigitalInput()    do { TRISB3 = 1; } while(0)
#define RED_LED_SetDigitalOutput()   do { TRISB3 = 0; } while(0)

#define RED_LED_SetPullup()    do { WPUB3 = 1; } while(0)
#define RED_LED_ResetPullup()   do { WPUB3 = 0; } while(0)
#define RED_LED_SetAnalogMode()   do { ANSB3 = 1; } while(0)
#define RED_LED_SetDigitalMode()   do { ANSB3 = 0; } while(0)
// get/set GREEN_LED aliases
#define GREEN_LED_TRIS               TRISB4
#define GREEN_LED_LAT                LATB4
#define GREEN_LED_PORT               RB4
#define GREEN_LED_WPU                WPUB4
#define GREEN_LED_ANS                ANSB4
#define GREEN_LED_SetHigh()    do { LATB4 = 1; } while(0)
#define GREEN_LED_SetLow()   do { LATB4 = 0; } while(0)
#define GREEN_LED_Toggle()   do { LATB4 = ~LATB4; } while(0)
#define GREEN_LED_GetValue()         RB4
#define GREEN_LED_SetDigitalInput()    do { TRISB4 = 1; } while(0)
#define GREEN_LED_SetDigitalOutput()   do { TRISB4 = 0; } while(0)

#define GREEN_LED_SetPullup()    do { WPUB4 = 1; } while(0)
#define GREEN_LED_ResetPullup()   do { WPUB4 = 0; } while(0)
#define GREEN_LED_SetAnalogMode()   do { ANSB4 = 1; } while(0)
#define GREEN_LED_SetDigitalMode()   do { ANSB4 = 0; } while(0)
// get/set U_I_SWITCH aliases
#define U_I_SWITCH_TRIS               TRISB5
#define U_I_SWITCH_LAT                LATB5
#define U_I_SWITCH_PORT               RB5
#define U_I_SWITCH_WPU                WPUB5
#define U_I_SWITCH_ANS                ANSB5
#define U_I_SWITCH_SetHigh()    do { LATB5 = 1; } while(0)
#define U_I_SWITCH_SetLow()   do { LATB5 = 0; } while(0)
#define U_I_SWITCH_Toggle()   do { LATB5 = ~LATB5; } while(0)
#define U_I_SWITCH_GetValue()         RB5
#define U_I_SWITCH_SetDigitalInput()    do { TRISB5 = 1; } while(0)
#define U_I_SWITCH_SetDigitalOutput()   do { TRISB5 = 0; } while(0)

#define U_I_SWITCH_SetPullup()    do { WPUB5 = 1; } while(0)
#define U_I_SWITCH_ResetPullup()   do { WPUB5 = 0; } while(0)
#define U_I_SWITCH_SetAnalogMode()   do { ANSB5 = 1; } while(0)
#define U_I_SWITCH_SetDigitalMode()   do { ANSB5 = 0; } while(0)
// get/set P2A aliases
#define P2A_TRIS               TRISB6
#define P2A_LAT                LATB6
#define P2A_PORT               RB6
#define P2A_WPU                WPUB6
#define P2A_ANS                ANSB6
#define P2A_SetHigh()    do { LATB6 = 1; } while(0)
#define P2A_SetLow()   do { LATB6 = 0; } while(0)
#define P2A_Toggle()   do { LATB6 = ~LATB6; } while(0)
#define P2A_GetValue()         RB6
#define P2A_SetDigitalInput()    do { TRISB6 = 1; } while(0)
#define P2A_SetDigitalOutput()   do { TRISB6 = 0; } while(0)

#define P2A_SetPullup()    do { WPUB6 = 1; } while(0)
#define P2A_ResetPullup()   do { WPUB6 = 0; } while(0)
#define P2A_SetAnalogMode()   do { ANSB6 = 1; } while(0)
#define P2A_SetDigitalMode()   do { ANSB6 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */